import static org.junit.Assert.*;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;


public class FailingTestSetAsTreeJUnit4 {

    static int nb_inc = 0;
    static int nb_fail = 0;


    public static void main(String args[]) {
    	String testClass = "FailingTestSetAsTreeJUnit4";
     	org.junit.runner.JUnitCore.main(testClass);
     }



    private void handleJMLAssertionError(org.jmlspecs.jmlrac.runtime.JMLAssertionError e) {
    	if (e.getClass().equals(org.jmlspecs.jmlrac.runtime.JMLEntryPreconditionError.class)) {
    	    System.out.println("\n INCONCLUSIVE "+(new Exception().getStackTrace()[0].getMethodName())+ "\n\t "+ e.getMessage());
            nb_inc++;}
    else{
	    // test failure	
	    nb_fail++;
	    junit.framework.Assert.fail("\n\t" + e.getMessage());	
		}  
    }
	
    
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		nb_inc = 0;
		nb_fail = 0;
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	     System.out.println("\n inconclusive tests: "+nb_inc+" -- failures : "+nb_fail );
	}

	@Test
	public void  testSequence_1() {
		try{
			SetAsTree s5=new SetAsTree(5);
			SetAsTree s1=new SetAsTree(1);
			s5.setRtree(s1);
			} catch (org.jmlspecs.jmlrac.runtime.JMLAssertionError e){
				handleJMLAssertionError(e);
				}	
		}


	
	@Test
	public void  testSequence_2() {
		try{
			SetAsTree s5=new SetAsTree(5);
			SetAsTree s0=new SetAsTree(0);
			s5.setLtree(s0);
			s0.setVal(null);
			//s5.skip();
			} catch (org.jmlspecs.jmlrac.runtime.JMLAssertionError e){
				handleJMLAssertionError(e);
				}	
		}
	
}
